#!/usr/local/bin/bpsh

# ARG handling
if { [llength $argv] >= 3 } {
	set host [lindex $argv 1]
	set username [lindex $argv 2]
	set password [lindex $argv 3]
	
	set clientport 0
	set clientinterface 1
	set serverport 1
	set serverinterface 2
} else {
	set scriptname [lindex $argv 0]
	puts "Usage: $scriptname <BPS ipaddr> <username> <password>"
	exit -1
}

# make sure the device isn't in use by another user
if { [catch {set bps [bps::connect $host $username $password -checkversion false]}]} {
	puts "\[!] Error connecting: $errorInfo"
	exit -1
}
puts "\[*] Connected..."

set name "DDoS TCP-1 SYN Flood"
puts "\[*] Creating test ${name}"
$bps configure -name $name

puts "\[*] Adding SessionSender Component"
set ss [$bps createComponent sessionsender {DDoS TCP-1}]
$ss configure -dstPortDist.type constant -dstPortDist.min 80 -packetsPerSession 0 -rateDist.min 400 -rateDist.max 1000 -rateDist.type random -sessions.maxPerSecond 500000 -sessions.max  5000000 -rampDist.upBehavior syn -rampDist.downBehavior rst -rampDist.steadyBehavior cycle+rst -rampDist.steady 120  

puts "\[*] Setting Network Neighborhood to DDoS Switching"
$bps setNeighborhood "DDoS Switching"
puts "\[*] Setting interface Domains to DDoS" 
$ss setDomain client $clientinterface "DDoS"
$ss setDomain server $serverinterface "DDoS"

puts "\[*] Saving Test"
$bps save -force

puts "\[*] Done!"
